summaryrefslogtreecommitdiffstats
path: root/audio/jack/jack.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'audio/jack/jack.SlackBuild')
-rw-r--r--audio/jack/jack.SlackBuild173
1 files changed, 173 insertions, 0 deletions
diff --git a/audio/jack/jack.SlackBuild b/audio/jack/jack.SlackBuild
new file mode 100644
index 0000000000..30fde24f08
--- /dev/null
+++ b/audio/jack/jack.SlackBuild
@@ -0,0 +1,173 @@
+#!/bin/bash
+
+# Slackware build script for jack (formerly jack2).
+
+# Copyright 2014 Yanes Checcacci Balod <email removed>, Brazil
+# Copyright 2014-2015 Marcel Saegebarth <email removed>
+# Copyright 2018 B. Watson <urchlay@slackware.uk>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# 20230511 bkw: update for v1.9.22. upstream split the tools off into
+# a separate repo, I modified this script to build them and include them
+# in this package (like PV does with vim and ctags).
+# 20220614 bkw: update for v1.9.21 and 15.0.
+# 20210802 bkw: update for v1.9.19 and -current.
+# 20210304 bkw: update for v1.9.17.
+# 20201104 bkw: update for v1.9.16.
+# 20200118 bkw: renamed from 'jack2' to 'jack'. If you want to see
+# the old log: "git log -- audio/jack2"
+# 20200112 bkw: get rid of --profile (thanks, dive!), BUILD=2.
+# 20191201 bkw: update for v1.9.14 (including new python3 dep).
+# 20180714 bkw:
+# - Take over maintenance.
+# - Update for v1.9.12.
+# - Move HTML docs to proper Slackware doc dir.
+# - i486 => i586.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=jack
+VERSION=${VERSION:-1.9.22}
+TOOLSVER=${TOOLSVER:-4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+SRCNAM=jack2
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i586"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+TOPDIR="$(pwd)"
+tar xvf $CWD/jack-example-tools-$TOOLSVER.tar.gz
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+
+# Minor source of incompatibility between jack 1.x and 2.x: some jack
+# apps don't add -lpthread to their CFLAGS because they assume jack.pc
+# will already include it (it does, in 1.x). So make 2 act like 1:
+sed -i '/^Libs:/s,$, -lpthread,' jack.pc.in
+
+# 20220614 bkw: upstream disabled the tools by default in 1.9.21, way
+# to handle a point release... --example-tools turns it back on.
+# 20230511 bkw: aaand in 1.9.22, they removed the tools entirely. Again,
+# way to handle a point release...
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="-Wl,-s" \
+./waf configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man/man1 \
+ --htmldir=/usr/doc/$PRGNAM-$VERSION/html \
+ --classic \
+ --dbus \
+ --alsa
+
+./waf build
+./waf install --destdir=$PKG
+
+# 20230511 bkw: now build the tools against the installed libs in $PKG.
+cd $TOPDIR
+sed "s,/usr,$PKG/usr,g" $PKG/usr/lib$LIBDIRSUFFIX/pkgconfig/jack.pc > jack.pc
+export PKG_CONFIG_PATH=$TOPDIR:$PKG_CONFIG_PATH
+cd jack-example-tools-$TOOLSVER
+mkdir build
+MFLAGS="$SLKCFLAGS -I$PKG/usr/include"
+cd build
+ CFLAGS="$MFLAGS" \
+ CXXFLAGS="$MFLAGS" \
+ LDFLAGS="-L$PKG/usr/lib$LIBDIRSUFFIX" \
+ meson .. \
+ --buildtype=release \
+ --infodir=/usr/info \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ -Dstrip=true
+ "${NINJA:=ninja}"
+ DESTDIR=$PKG $NINJA install
+cd ..
+
+gzip $PKG/usr/man/man?/*
+
+PKGDOC=$PKG/usr/doc/$PRGNAM-$VERSION
+PKGDOC2=$PKGDOC/jack-example-tools-$TOOLSVER
+mkdir -p $PKGDOC2
+cp -a LICENSE *.md $PKGDOC2
+cd $TOPDIR
+cp -a AUTHORS* COPYING* ChangeLog* README* $PKGDOC
+cat $CWD/$PRGNAM.SlackBuild > $PKGDOC/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+# Only add capability stuff if not disabled:
+if [ "${SETCAP:-yes}" = "yes" ]; then
+ # 20230719 bkw: dynamically create the list instead of hardcoding.
+ # there's at least one symlink, hence find and xargs.
+ BINS="$( cd $PKG/usr/bin && find * -type l -o -print | xargs echo )"
+ sed "s,@BINS@,$BINS," < $CWD/setcap.sh >> $PKG/install/doinst.sh
+ # Only allow execution by audio group
+ chown root:audio $PKG/usr/bin/*
+ chmod 0750 $PKG/usr/bin/*
+fi
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE